//slideshowJSm v1.0
//-------------------
//　ユーザー設定部
//-------------------

//スライドショー用初期値
var fade = true; //フェード true:オン、false：オフ
var speed = 33; //フェードスピード。→大：フェードが遅くなる。spped/1000秒
var change = 15; //フェードステップ量。この値を大きくするとフェードが粗くなる。

var imageFolder = "image"; //画像を入れているフォルダ名

//------↓ 以下変更不要 ↓--------
//--------------------------
//　オブジェクトID取得
//--------------------------
var doc = document;
var oLay = doc.getElementById("overlay");
var sBox = doc.getElementById("slidebox");
var gTitle = doc.getElementById("gallery-title");
var sArea = doc.getElementById("slidearea");
var fGly = doc.getElementById("formgly");
var sGly = doc.getElementById("selectgly");
var count = doc.getElementById("cnt");
var comment = doc.getElementById("cmt");
var help = doc.getElementById("helpbox");

var imgComs = new Array(); //xmlの各infoフォルダオブジェクトを入れる配列
//--------------------------
//　各変数初期値設定
//--------------------------
var wx,kc,fName,totalNum,imageDir,no,slideState,timerID;
var emp          = "";
var initialHash  = [];
var initialImage = "parts/start.gif";

//ブラウザ判定
var bw = navigator.userAgent;
var ckCamino = bw.indexOf("Camino"); //Caminoはblur()に未対応なのでセレクトフォームをdisplay:noneにする。
var ckSafari = bw.indexOf("Safari"); //safariはセレクトフォームでdisabledが選択可能なのでこれを解決する為
var ckIe     = bw.indexOf("msie");   //#overlayのリサイズにIE用の処理を追加


//--------------------------
//　ブラウザの幅、高さを取得
//--------------------------
function getWindowWidth(){
	return ( window.innerWidth ) ? window.innerWidth : doc.documentElement.clientWidth;
}

function getWindowHeight(){
	return ( window.innerHeight ) ? window.innerHeight : doc.documentElement.clientHeight;
}

//---------------------
//　オブジェクト定義
//---------------------
var SLIDEobj = function(obj,id){
	this._element = doc.getElementById(id);
	this._style = this._element.style;
	this._obj = obj;
	this._imgLoading = false;
}

//--------------------
//　オブジェクト生成
//--------------------
var Photoobj = new SLIDEobj("Photoobj","slideImg");
var Loadobj  = new SLIDEobj("Loadobj","loader");
var Prevobj  = new SLIDEobj("Prevobj","prev");
var Nextobj  = new SLIDEobj("Nextobj","next");


//--------------------------
//　オブジェクト表示関連
//--------------------------
SLIDEobj.prototype.show = function(){ this._style.visibility = "visible"; }
SLIDEobj.prototype.hide = function(){ this._style.visibility = "hidden"; }


//--------------------------
//　リサイズ
//--------------------------

//背景のリサイズ
function resizeOverLay(){
	oLay.style.height = getWindowHeight() + "px";
	if(ckIe){ oLay.style.width = getWindowWidth() + "px"; }
}

//ウィンドウリサイズ時ローディング画像位置変更

function setLoader(){
	wx = getWindowWidth();
	Loadobj._style.left = (wx/2)-16 + "px";
}

window.onresize = function(){
	resizeOverLay();
	setLoader();
}

//------------------
//　フェード関連
//------------------
SLIDEobj.prototype.setOpacity = function(opacity){ 
	opacity = (opacity == 100)?99.999:opacity;
	this._style.filter     = "alpha(opacity=" + opacity + ")";
	this._style.MozOpacity = opacity/100;
	this._style.opacity    = opacity/100;
}

SLIDEobj.prototype.fadeIn = function(opacity, change, speed){ 
	if (opacity <= 100){
		this.setOpacity(opacity);
		opacity += change;
		setTimeout(this._obj + ".fadeIn(" + opacity + "," + change + "," + speed + ")", speed);
	} else {
		this.setOpacity(100);
		this._imgLoading = false;
	}
}


//------------------------------
//　画像表示と画像サイズの取得
//------------------------------
SLIDEobj.prototype.setImg = function(num){ 
	this._element.onload = function(){
		Loadobj.hide();
		Photoobj.show();
		if(fade == true){ 
			Photoobj.fadeIn(0,change,speed);
		} else {
			Photoobj._imgLoading = false;
		}
	}
	if(num < 10){ num = "0" + num; }
	this._element.src = imageDir + num + ".jpg";
}


//------------------------------
//　画像カウンタ、コメント取得
//------------------------------
function setCombox(imgno){
	count.innerHTML   = imgno + "/" + totalNum;
	comment.innerHTML = imgComs[imgno-1];
}

//------------------------------
//　画像表示用タイマー起動
//------------------------------
function setTimer(imgno){
	Loadobj.show();
	setCombox(imgno);
	timerID = setTimeout("Photoobj.setImg("+imgno+")",125);
}

//------------
//　画像送り
//------------
function next(){
	if (no == totalNum) { no = 1; } else { no++; }
	setTimer(no);
}

function prev(){
	if (no == 1) { no = totalNum; } else { no--; }
	setTimer(no);
}

//----------------------------------------
//　next,prev時画像、ナビ画像を非表示
//----------------------------------------
function objHide(){
	Photoobj._imgLoading = true;
	Photoobj.hide();
	Prevobj.hide();
	Nextobj.hide();
}


//----------------------------------------------
//　クリック位置を判定しprev,nextに振り分ける
//----------------------------------------------
function clMouse(cx){
	if(Photoobj._imgLoading == false){
		objHide();
		wx = getWindowWidth();
		if (cx > (wx /2)){ next(); } else { prev(); }
	}
}


//----------------------------------------------
//　カーソルキーでprev,nextに振り分け、ESCでクローズ
//----------------------------------------------
doc.onkeyup = function(evt){
	if(slideState == true && Photoobj._imgLoading == false){
		kc = (window.event) ? window.event.keyCode : evt.keyCode;
		if(kc == 39){
			objHide();
			next();
		} else if(kc == 37){
			objHide();
			prev();
		} else if(kc == 27){ //esc:スライドショー終了
			slideHide();
		}
	}
	return false; //safariではキーの動作が2回発生してしまう問題の対策
}

//----------------------------------------------
//　マウス位置判定し、矢印を表示・非表示
//----------------------------------------------
function mvMouse(mx){
	if(Photoobj._imgLoading == false){
		wx = getWindowWidth();
		if( mx > (wx / 2) ){
			Prevobj.hide();
			Nextobj.show();
		} else {
			Prevobj.show();
			Nextobj.hide();
		}
	}
}

//#slideareaからマウスが外れたら、矢印を非表示
function outMouse(){
	Prevobj.hide();
	Nextobj.hide();
}

//-----------------------
//　HttpRequestを作成
//-----------------------
function createHttpRequest(){
	if(window.XMLHttpRequest) {
		//WinIE以外のブラウザ用
		return new XMLHttpRequest();
	} else if(window.ActiveXObject){
		//WinIE用
		try { 
			return new ActiveXObject("Msxml2.XMLHTTP"); 
		} catch(e) {
			try {
				return new ActiveXObject("Microsoft.XMLHTTP");
			} catch(e) {
				return null;
			}
		}
	} else {
		//上記以外
		return null;
	}
}

//--------------------------
//　スライドショー開始
//--------------------------
function slideShow(){
	slideState = true;
	objHide();
	no = 1;
	setTimer(1);
}
//-----------------------
//　テキストデータを取得
//-----------------------
function getData(){
	var request = null;
	request = createHttpRequest();
	request.onreadystatechange = function () {
		if(request.readyState==4 && request.status==200){
			var txtData = request.responseText;
			if(ckSafari > -1){ //SafariのみtxtDataの値が文字化けするので対策する
				var esc = escape(txtData);
				if(esc.indexOf("%u") < 0 && esc.indexOf("%") > -1){
					txtData = decodeURIComponent(esc);
				}
			}
			var TC = txtData.split("::::");
			imgComs = TC[1].split("<>");
			gTitle.innerHTML = TC[0];
			totalNum = imgComs.length;
			slideShow(); //スライドショー開始
		}
	}
	request.open("GET",fName+"/slidedata.txt",true);
	request.send(null);
}


//--------------------------
//　各変数を初期化
//--------------------------
function initialize(){
	clearTimeout(timerID);
	fGly.reset();                          //#slideareaを非表示にした時、フォームをリセット
	imgComs = initialHash;                 //slidedata.txtのコメントデータを入れる配列
	totalNum = 0;                          //画像数
	imageDir = emp;                        //画像ファイルのディレクトリ
	fName = emp;                           //各写真のフォルダ 
	gTitle.innerHTML = emp;                //スライドショータイトル
	count.innerHTML = emp;                 //カウント
	comment.innerHTML = emp;               //コメント
	no = 1;                                //画像用カウント初期値
	Photoobj._element.src = initialImage;  //画像データ
	slideState = false;                    //スライドショー動作を示すフラッグ
}

//----------------------------------------------
//　スライドショー開始基点。フォルダ名を取得
//----------------------------------------------
function getFolderName(folder){
	//スライドショー開始方法によって、フォルダ名取得方法を変える
	if(folder){
		fName = folder;
	} else {
		fName = sGly.options[sGly.selectedIndex].value;

		//safari対策：disabledの値（-文字-）がfNameに入っていたら削除
		if(ckSafari > -1){ fName = fName.replace(/-+.*-+/,emp); } 
	}
	setSlideshow();
}

//----------------------------------------------
//　スライドショーディレクトリ設定と前準備
//----------------------------------------------
function setSlideshow(folder){
	if(fName && fName != "csm"){
		imageDir = fName + "/" + imageFolder + "/"; //画像ディレクトリ設定
		resizeOverLay();
		setLoader();
		oLay.style.display = "block";
		sBox.style.display = "block";
		if(ckCamino < 0){ 
			sGly.style.visibility = "hidden"; //IEでは最前面に出てくるので消す
			sGly.blur(); //セレクトメニューからフォーカスを外す(Camino以外が対象)
		} else { 
			sGly.style.display = "none"; //caminoはblurが効かないのでdisplay=noneを使用
		}
		getData(); //xmlデータを取得
	} else if(!fName){ //IE,Safari対策：disabledが選択可能な為
		fGly.reset();
	}
}


//--------------------------
//　スライドショー終了
//--------------------------
function slideHide(){ 
	sBox.style.display = "none";
	oLay.style.display = "none";
	if(ckCamino < 0){ sGly.style.visibility = "visible"; } else { sGly.style.display = "inline"; }
	initialize(); //各変数に初期値を入れる
}

//----------------
//　ヘルプ表示
//----------------
function showHelp(hd){
	if(hd == "sh"){
		help.style.display = "block";
	} else if(hd == "hh"){
		help.style.display = "none";
	}
}